/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18857
        Driver Version    :  2.00
 
  74HC595 - PIC: 
    A_SI(U2) - RB7
    A_SCK(U2) - RB6 
    A_RCK(U2) - RB5 
    C_SI(U3/U4) - RB4 
    C_SCK(U3/U4) - RB3
    C_RCK(U3/U4) - RB2 
    G_Red(U3/U4) - RB1 
    G_Grn(U3/U4) - RB0 
 
  74HC595 - Matrix_LED(LTP-12188M-08): 
    U2(Anode)
        QA - A_8(#12) 
        QB - A_7(#9)
        QC - A_6(#6)
        QD - A_5(#3)
        QE - A_4(#13)
        QF - A_3(#16)
        QG - A_2(#19)
        QH - A_1(#22)
 
    U3(Cathode_Red) 
        QA - C_8(#11) 
        QB - C_7(#8)
        QC - C_6(#5)
        QD - C_5(#2)
        QE - C_4(#14)
        QF - C_3(#17)
        QG - C_2(#20)
        QH - C_1(#23)
 
    U4(Cathode_Green) 
        QA - C_8(#10) 
        QB - C_7(#7)
        QC - C_6(#4)
        QD - C_5(#1)
        QE - C_4(#15)
        QF - C_3(#18)
        QG - C_2(#21)
        QH - C_1(#24)

  PIC peripherals:
    RC3 - 10k VR   
    RC4 - SHT31_SDA 
    RC5 - SHT31_SCL 
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <string.h>     // memmove֐gp
#include "i2c-lib.h"

// LN^[
__EEPROM_DATA(0x00,0x3E,0x41,0x41,0x41,0x3E,0x00,0x00);     // 0
__EEPROM_DATA(0x00,0x00,0x21,0x7F,0x01,0x00,0x00,0x00);     // 1
__EEPROM_DATA(0x00,0x21,0x43,0x45,0x49,0x31,0x00,0x00);     // 2
__EEPROM_DATA(0x00,0x42,0x41,0x51,0x69,0x46,0x00,0x00);     // 3
__EEPROM_DATA(0x00,0x0C,0x14,0x24,0x7F,0x04,0x00,0x00);     // 4
__EEPROM_DATA(0x00,0x72,0x51,0x51,0x51,0x4E,0x00,0x00);     // 5
__EEPROM_DATA(0x00,0x1E,0x29,0x49,0x49,0x06,0x00,0x00);     // 6
__EEPROM_DATA(0x00,0x40,0x47,0x48,0x50,0x60,0x00,0x00);     // 7
__EEPROM_DATA(0x00,0x36,0x49,0x49,0x49,0x36,0x00,0x00);     // 8
__EEPROM_DATA(0x00,0x30,0x49,0x49,0x4A,0x3C,0x00,0x00);     // 9
//__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);

// xZT[X[uAhX`t
#define SHT31_ADDR 0x8A         // 0b1000101(0x45)+0 = 0b10001010 = 0x8A

// Pin̒`t(TC74HC595 - PIC)
#define A_SI RB7    // SI(Am[h) - RB7
#define A_SCK RB6   // SCK(Am[h) - RB6 
#define A_RCK RB5   // RCK(Am[h) - RB5 
#define C_SI RB4    // SI(J\[h) - RB4 
#define C_SCK RB3   // SCK(J\[h) - RB3
#define C_RCK RB2   // RCK(J\[h) - RB2 
#define G_Red RB1   // /G(Red) - RB1 
#define G_Grn RB0   // /G(Green) - RB0 

// O[oϐ錾
unsigned int Table[8];      // \pobt@
unsigned int Temp10[8];     // x(10̈)obt@
unsigned int Temp01[8];     // x(1̈)obt@
unsigned int Humi10[8];     // x(10̈)obt@
unsigned int Humi01[8];     // x(1̈)obt@ 

unsigned long Adrs;         // AhXϐ
unsigned long StartAdrs;    // f[^ǂݏoJnAhX 
unsigned long EndAdrs;     // f[^ǂݏoIAhX

unsigned long RedStart = 0;     // ԐF\JnAhX
unsigned long RedEnd = 23;      // ԐF\IAhX
unsigned long GreenStart = 39;   // ΐF\JnAhX       
unsigned long GreenEnd = 55;     // ΐF\IAhX

unsigned long Temp,Humi;        // Temp:xϐ,Humi:xϐ
unsigned long data[6];          // SHT31WX^Mf[^i[p   

unsigned int Index;       // EEPROMAhXCfbNX
unsigned long eepadrs;      // EEPROMǂݏoAhX

unsigned int *pt;       // \Fp|C^

unsigned int Array[] = {
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    // x Temp10(10̈)ubN (0-7)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    // x Temp01(1̈)ubN (8-15)
0x00,0x40,0xA0,0x40,0x1E,0x21,0x21,0x12,    // (P) (16-23)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,   //  (24-31)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    // x Humi10(10̈)ubN (32-39)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,    // x Humi01(1̈)ubN (40-47)
0x00,0x42,0xA4,0x48,0x10,0x24,0x4A,0x84,    // (P) (48-55)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};    //  (56-63)

// vg^Cv錾
void Disp();        // \֐
void Shift();       // Vtg֐
void SHT31();   // xZT[֐
void Conv();    // xlϊ֐
void Charcopy();    // EEPROMLN^[Rs[֐
void Number();      // EEPROMǂݏoAhXw֐

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code

        StartAdrs = 0;      // f[^ǂݏoJnAhXw
        EndAdrs = 64;      // f[^ǂݏoIAhXw        

        SHT31();    // xZT[֐Ăяo            
        
        Shift();     // Vtg֐Ăяo             
    }
}

void Shift()     // Vtg֐
{
    unsigned int i;        

    while (1)
    {
        // xxzobt@ArrayɃRs[
        memmove(Array,Temp10,8);        // Array̐擪ԒnTemp10̎8 byteRs[
        memmove(Array+8,Temp01,8);      // Array̐擪Ԓn+8 byteڂTemp018 byteRs[
        memmove(Array+32,Humi10,8);     // Array̐擪Ԓn+32 byteڂHumi108 byteRs[
        memmove(Array+40,Humi01,8);     // Array̐擪Ԓn+40 byteڂHumi018 byteRs[
        
        Adrs = StartAdrs;   // Adrsϐ
        
        for(i=0; i<8; i++) {
            Table[i] = Array[Adrs];   // ArrayTableɃRs[            
            Adrs++;     // AdrsCNg
            if (Adrs > EndAdrs)     // Adrs > EndAdrsȂAdrsZbg        
                Adrs = 0;
        }            

        Disp();     // \֐Ăяo        
        
        StartAdrs++;    // StartAdrsCNg
        if (StartAdrs > EndAdrs)    //StartAdrs > EndAdrsȂ烋[v𔲂 
            break;    
    }
}

void Disp()     // \֐
{
    unsigned long VADC;     // ADCϊli[p
    unsigned int A_Pos;     // Am[hp
    unsigned int i,j,k,p;     // \pϐ
    
    VADC = ADCC_GetSingleConversion(channel_ANC3);      // ADCϊʂVADCɊi[
    p = VADC / 5;

    for(k=0; k<p; k++) {       // XN[x        

        A_Pos = 0x01;   // Am[hrbgq   
       
        for(i=0; i<8; i++) {

            for(j=0; j<8; j++) {
// J\[hVtgWX^]                
                if (((~(Table[i]) >> j) & 1) == 1)     // Table[i]rbg]ărbg
                    C_SI = 1;            
                else
                    C_SI = 0;

                C_SCK = 1;      // VtgWX^ɃVAM荞            
                C_SCK = 0;

// Am[hVtgWX^]
                if (((A_Pos >> j) & 1) == 1)     // Am[h̃rbg            
                    A_SI = 1;            
                else
                    A_SI = 0;

                A_SCK = 1;      // VtgWX^ɃAm[h荞            
                A_SCK = 0;
            }
            
            A_Pos <<= 1;    // rbgq1rbgVtg            

// 3Xe[gobt@
            pt = &Table[Adrs + i];      // pt(|C^ϐ)Table[Adrs + i]AhX
            
// tH[}bg͞(+)
            G_Red = 0;      // 3Xe[gobt@():able
            G_Grn = 0;      // 3Xe[gobt@():able            

// x͐ԐF            
            if((pt >= &Table[RedStart]) && (pt <= &Table[RedEnd]))  // ԐF\            
                G_Grn = 1;      // 3Xe[gobt@():disable

// x͗ΐF            
            if((pt >= &Table[GreenStart]) && (pt <= &Table[GreenEnd]))  // ΐF\
                G_Red = 1;      // 3Xe[gobt@():disable
            
            C_RCK = 1;      // Xg[WWX^(J\[h)o            
            C_RCK = 0;           

            A_RCK = 1;      // Xg[WWX^(Am[h)o
            A_RCK = 0;
        }            
    }        
}

// xZT[֐
void SHT31(void) {
// FxANbNXgb`

    unsigned int i;

// R}hM    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR);      // X[uID + 0(ݗv)
    i2c_send_byte(0x24);            // R}h(MSB) = 0x24 : NbNXgb`
    i2c_send_byte(0x0B);            // R}h(LSB) = 0x0B : xuv   
    i2c_stop();                     // I2CXgbvRfBVs     

    __delay_ms(5);                  // ҂ (x:m~i 4.5 msec)

// xf[^ǂݏo    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR + 1);  // X[uID + 1(ǂݍݗv)
    for (i=0; i<6; i++)             // f[^荞
    {
        if (i == 5)
            data[5] = i2c_read_byte(0);     // ŏIWX^MNACK
        else
            data[i] = i2c_read_byte(1);     // ȊO͎MACKԂ   
    }

    i2c_stop();             // I2CXgbvRfBVs     

    Conv();                 // xlϊ֐Ăяo
}

// xlϊ֐
void Conv(void) {

    unsigned long St,Srh;           // xx16bitf[^i[p
   
// xZFT = -45 + 175 * St / (2^16-1)    
// x16bit(MSB+LSB)2i10iɕϊ
    St = (data[0] << 8) | data[1];          // x16bit(MSB+LSB) 
    Temp = St * 175 / 65535 - 45;           // 2^16-1 = 65535
    
// xZFRH = 100 * Srh / (2^16-1)
// x16bit(MSB+LSB)2i10iɕϊ
    Srh = (data[3] << 8) | data[4];          // x16bit(MSB+LSB)
    Humi = Srh * 100 / 65535;                //         
// CRC͏Ȃ()

    Charcopy();     // EEPROMLN^[̃Rs[ 
}

// EEPROMLN^[Rs[֐
void Charcopy(void) {

    unsigned int i;    
    
    // EEPROMLN^[obt@ɃRs[    
    Index = Temp / 10;      // x10̈
    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Temp10[i] = eeprom_read(eepadrs);   // EEPROM10̈ʂ̃LTemp10ɃRs[
        eepadrs++;
    }

    Index = Temp % 10;      // x1̈
    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Temp01[i] = eeprom_read(eepadrs);   // EEPROM1̈ʂ̃LTemp01ɃRs[
        eepadrs++;
    }    

    Index = Humi / 10;      // x10̈
    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Humi10[i] = eeprom_read(eepadrs);   // EEPROM10̈ʂ̃LHumi10ɃRs[
        eepadrs++;
    }

    Index = Humi % 10;      // x1̌
    Number();      // EEPROMǂݏoAhXw
    for (i=0; i<8; i++) {
        Humi01[i] = eeprom_read(eepadrs);   // EEPROM1̈ʂ̃LHumi01ɃRs[
        eepadrs++;
    }
}

// EEPROMǂݏoAhXw֐
void Number(void) {

    switch(Index) {
        case 0:
            eepadrs = 0;    //u0v
            break;

        case 1:
            eepadrs = 8;    //u1v
            break;            
            
        case 2:
            eepadrs = 16;   //u2v
            break;            

        case 3:
            eepadrs = 24;   //u3v 
            break;

        case 4:
            eepadrs = 32;   //u4v
            break;

        case 5:
            eepadrs = 40;   //u5v
            break;

        case 6:
            eepadrs = 48;   //u6v
            break;

        case 7:
            eepadrs = 56;   //u7v
            break;

        case 8:
            eepadrs = 64;   //u8v
            break;

        case 9:
            eepadrs = 72;   //u9v
            break;

        default:
            break;            
    }
}

/**
 End of File
*/